<?php
    namespace Sbuerk\TmenuTest;

    /**
     * Class ParentMenuArr
     *
     * Test itemArrayProcFunc functions to test old and new.
     */
    class ParentMenuArr {

        /**
         * @param $menuArr
         * @param $conf
         *
         * @return array
         */
        public function topLevelCheck($menuArr, $conf) {

            /** @var \TYPO3\CMS\Frontend\ContentObject\Menu\AbstractMenuContentObject $parentObj */
            $parentObj          = $conf['parentObj'];

            if ($parentObj->menuNumber === 1) {

                if (!isset($parentObj->parentMenuArr)) {

                    echo "<pre>" . PHP_EOL;
                    echo "TopLevel - parentMenuArr not set." . PHP_EOL;
                    echo "Typo 6.2.26 -> dev" . PHP_EOL;
                    echo "Eventually okay, since was behaviour in the past. (Without Patch)" . PHP_EOL;
                    echo "</pre>";
                    die();

                } else {

                    // patch should be applied
                    if (is_array($parentObj->parentMenuArr) && empty($parentObj->parentMenuArr)) {
                        echo "<pre>" . PHP_EOL;
                        echo "Patched applyed - empty parentMenuArr array expected and found " . PHP_EOL;
                        echo "Using the public member still opens some caveats, that it could be set" . PHP_EOL;
                        echo "to something else. For that the new getter was implemented." . PHP_EOL;
                        echo "</pre>";
                        die();
                    } else {
                        echo "<pre>" . PHP_EOL;
                        echo "parentMenuArr set, but " . PHP_EOL;
                        echo "</pre>" . PHP_EOL;
                        die();
                    }
                }
            }

            return $menuArr;
        }

        /**
         * Fetching ITEM_STATE of direct parent menu item in
         * subMenu itemArrayProcFunc.
         *
         * After applying the patch, this itemArrayProcFunc should work again.
         *
         * @param $menuArr
         * @param $conf
         *
         * @return array
         */
        public function level2Working62Broken76($menuArr, $conf) {

            /** @var \TYPO3\CMS\Frontend\ContentObject\Menu\AbstractMenuContentObject $parentObj */
            $parentObj          = $conf['parentObj'];

            // check if we are a subMenu
            if ($parentObj->menuNumber > 1)
            {

                if (isset($parentObj->parentMenuArr) && is_array($parentObj->parentMenuArr))
                {
                    // okay, working condition

                    $parentMenuItemState = null;

                    // iterate over the menuArr of the parentMenu
                    // to find the direct parent menu item for
                    // the current subMenu, matching through
                    // comparing the uid/id.
                    foreach($parentObj->parentMenuArr AS $pma) {
                        if ((int)$pma['uid'] === (int)$parentObj->id) {
                            $parentMenuItemState = (isset($pma['ITEM_STATE']) ? $pma['ITEM_STATE'] : '');
                            break;
                        }
                    }

                    if (null === $parentMenuItemState) {
                        echo "<pre>" . PHP_EOL;
                        echo "Could not retrieve the ITEM_STATE of the direkt parent menu item of current submenu." . PHP_EOL;
                        echo "Worked in 6.2.26, broken in >7.6.9" . PHP_EOL;
                        echo "</pre>";
                    } else if('' === $parentMenuItemState) {
                        echo "<pre>" . PHP_EOL;
                        echo "ParentItem found, but state was not set yet. MaybeNot processed yet." . PHP_EOL;
                        echo "This behavour occurs, because the parent item state is set through the generate() method," . PHP_EOL;
                        echo "after subMenus are created." . PHP_EOL;
                        echo " - topLevel prozess items".PHP_EOL;
                        echo " - topLevel item -> create, make, itemArrayProcFunc and generate of submenu" . PHP_EOL;
                        echo " -> topLevel generate -> which runs the procesItemStates method" . PHP_EOL;
                        echo "" . PHP_EOL;
                        echo "Only present if custom set through topLevel itemArrayProcFunc" . PHP_EOL;
                        echo "" . PHP_EOL;
                        echo "==> Okay, since was old way it works." . PHP_EOL;
                        echo "</pre>".PHP_EOL;
                        //die();
                    } else {
                        echo "<pre>" . PHP_EOL;
                        echo "ParentMenuArr and direct parent menu item ITEM_STATE retrieved." . PHP_EOL;
                        echo "If Typo >= 7.6.9 the patch was appled and old behavior restored." . PHP_EOL;
                        echo "Still public member is not very nice" . PHP_EOL;
                        echo "Maybe set through parent menu itemArrayProcFunc" . PHP_EOL;
                        echo "ParentItemState: " . $parentMenuItemState . PHP_EOL;
                        echo "" . PHP_EOL;
                        echo "Note: parent item state could only be retrieved, if set through itemArrayProcFunc from" . PHP_EOL;
                        echo "      the parentMenu." . PHP_EOL;
                        echo "</pre>";
                    }
                } else {

                    // broken condition
                    echo "<pre>" . PHP_EOL;
                    echo "Failed - parentMenuArr not defined." . PHP_EOL;
                    die();
                }
            }

            return $menuArr;
        }


        /**
         * Getting the parentMenuArr in a itemArrayProcFunc from submenu
         * using the new getter instead of the public class member.
         *
         * Only works with the patch. These methods are new and meant
         * as replacement for the public member parentMenuArr.
         *
         * @param $menuArr
         * @param $conf
         *
         * @return array
         */
        public function level2TestingNewGetter($menuArr, $conf)
        {

            /** @var \TYPO3\CMS\Frontend\ContentObject\Menu\AbstractMenuContentObject $parentObj */
            $parentObj      = $conf['parentObj'];

            // get the whole parent menu arr
            $parentMenuArr  = $parentObj->getParentMenuArr();

            // get the direct parent menu item directly,
            // without parsing the parent menuArr array again
            // and matching the page
            $parentMenuItem = $parentObj->getParentMenuItem();

            if ($parentObj->menuNumber === 1) {

                echo "<pre>" . PHP_EOL;
                echo "NewGetter - TopLevel" . PHP_EOL;

                // on top level parentMenuItem is always null,
                // but getParentMenuArr() should always be an
                // array
                if (!is_array($parentMenuArr)) {
                    echo "Failed - parentMenuArr is not an array - should always be" . PHP_EOL;
                } else if (empty($parentMenuArr)) {
                    echo "Okay - parentMenuArr is an array, even on toplevel, but empty as expected." . PHP_EOL;
                } else {
                    echo "parentMenuArr is an array, but not empty ... this was not expected on top level." . PHP_EOL;
                }

                if (null !== $parentMenuItem) {
                    echo "Failed - on toplevel parentMenuItem should be alyways null" . PHP_EOL;
                } else {
                    echo "Okay - parentMenuItem is null on top level" . PHP_EOL;
                }

                echo "</pre>";
                //die();
            }

            if ($parentObj->menuNumber > 1) {
                echo "<pre>" . PHP_EOL;
                echo "NewGetter - SubMenu (MenuLevel > 1) " . $parentObj->menuNumber . PHP_EOL;

                // on top level parentMenuItem is always null,
                // but getParentMenuArr() should always be an
                // array
                if (!is_array($parentMenuArr)) {
                    echo "Failed - parentMenuArr is not an array - should always be" . PHP_EOL;
                } else if(is_array($parentMenuArr) && empty($parentMenuArr)) {
                    echo "Okay, parentMenuArr was an array as expected, but" . PHP_EOL;
                    echo "it was empty. On second level there should be at" . PHP_EOL;
                    echo " minimum one item in the parentMenuArr" . PHP_EOL;
                } else if(is_array($parentMenuArr) && !empty($parentMenuArr)) {
                    echo "Okay, parentMenuArr was an array as expected and was not empty".PHP_EOL;
                    echo "on second level there should be at" . PHP_EOL;
                    echo "minimum one item in the parentMenuArr" . PHP_EOL;
                } else {
                    echo "This state should never occour" . PHP_EOL;
                }
                echo "</pre>";
            }

            return $menuArr;
        }

        /**
         * Fakes a item state.
         *
         * @param $menuArr
         * @param $conf
         *
         * @return array
         */
        public function fakeMenuArr($menuArr, $conf) {
            $m = array();
            foreach($menuArr AS $ma) {
                $ma['ITEM_STATE'] = 'USERDEF1';
                $m[] = $ma;
            }

            return $m;
        }
    }